## Contribution List

The model reproduction work in the library has been assisted by several developers. The specific contribution list is shown below.

For a list of all models reproduced in LibCity, see [Docs](https://libcity.ai/Bigscity-LibCity-Docs/user_guide/model.html#), where you can see the abbreviation of the model and the corresponding papers and citations.

| Task | Model  | Contributor                                                  |
| ------ | ------------------------------------------------------------ | ------ |
|Time Series Prediction|HA|[XBR-1111](https://github.com/XBR-1111), [aptx1231](https://github.com/aptx1231)|
||ARIMA|[l782993610](https://github.com/l782993610), [aptx1231](https://github.com/aptx1231)|
||VAR|[aptx1231](https://github.com/aptx1231), [excelsior399](https://github.com/excelsior399)|
||SVR| [aptx1231](https://github.com/aptx1231), [buaacjw](https://github.com/buaacjw) |
|Traffic State Prediction|RNN-2|[aptx1231](https://github.com/aptx1231)|
||Seq2Seq|[aptx1231](https://github.com/aptx1231)|
||AutoEncoder|[aptx1231](https://github.com/aptx1231)|
||FNN|[NickHan-cs](https://github.com/NickHan-cs)|
|Traffic Flow Prediction|ACFM|[aptx1231](https://github.com/aptx1231)|
||ACFMCommon|[aptx1231](https://github.com/aptx1231)|
||AGCRN|[aptx1231](https://github.com/aptx1231)|
||ASTGCN|[aptx1231](https://github.com/aptx1231)|
||ASTGCNCommon|[aptx1231](https://github.com/aptx1231)|
||ASTGNN|[luiluizi](https://github.com/luiluizi)|
||ASTGNNCommon|[luiluizi](https://github.com/luiluizi)|
||DSTAGNN|[hczs](https://github.com/hczs)|
||ESG|[Kazeya27](https://github.com/Kazeya27)|
||FOGS|[hczs](https://github.com/hczs)|
||MSTGCN|[aptx1231](https://github.com/aptx1231)|
||MSTGCNCommon|[aptx1231](https://github.com/aptx1231)|
||MultiSPANS|[Kazeya27](https://github.com/Kazeya27)|
||PDFormer|[Kazeya27](https://github.com/Kazeya27)|
||RGSL|[hczs](https://github.com/hczs)|
||SSTBAN|[hczs](https://github.com/hczs)|
||STGNCDE|[luiluizi](https://github.com/luiluizi)|
||STGODE|[Kazeya27](https://github.com/Kazeya27)|
||STNorm| [luiluizi](https://github.com/luiluizi)                      |
|                                      | STPGCN               |[hczs](https://github.com/hczs)|
||STResNet|[aptx1231](https://github.com/aptx1231)|
||STPGCNSTResNetCommon|[aptx1231](https://github.com/aptx1231)|
||STSSL|[Lucas-lyh](https://github.com/Lucas-lyh)|
||ST-TSNet|[hczs](https://github.com/hczs)|
||STWave|[hczs](https://github.com/hczs)|
||SimST|[hczs](https://github.com/hczs)|
||TimeMixer|[hczs](https://github.com/hczs)|
||DGCN|[aptx1231](https://github.com/aptx1231)|
||DSAN|[XBR-1111](https://github.com/XBR-1111)|
||CRANN|[aptx1231](https://github.com/aptx1231)|
||STSGCN|[Y-Claw](https://github.com/Y-Claw), [l782993610](https://github.com/l782993610), [aptx1231](https://github.com/aptx1231)|
||CONVGCN|[XBR-1111](https://github.com/XBR-1111), [wang-lucy](https://github.com/wang-lucy)|
||CONVGCNCommon|[XBR-1111](https://github.com/XBR-1111)|
||ResLSTM|[NickHan-cs](https://github.com/NickHan-cs), [GawsonZz](https://github.com/GawsonZz)|
||STDN|[NickHan-cs](https://github.com/NickHan-cs), [8igfive](https://github.com/8igfive)|
||ToGCN|[XBR-1111](https://github.com/XBR-1111)|
||MultiSTGCnet|[wyooyw](https://github.com/wyooyw)|
||MultiSTGCnetCommon|[XBR-1111](https://github.com/XBR-1111)|
||STNN|[mjh12138](https://github.com/mjh12138), [01010122](https://github.com/01010122)|
||FreTS|[Kazeya27](https://github.com/Kazeya27)|
|Traffic Speed Prediction| DCRNN          | [aptx1231](https://github.com/aptx1231)                      |
|| D2STGNN | [NickHan-cs](https://github.com/NickHan-cs) |
|| DMSTGCN | [Kazeya27](https://github.com/Kazeya27) |
|| HIEST | [Kazeya27](https://github.com/Kazeya27) |
|| MegaCRN | [hczs](https://github.com/hczs) |
|| STAFormer | [hczs](https://github.com/hczs) |
|| STID | [smilehan](https://github.com/2448845600) |
|                                     | STGCN          | [aptx1231](https://github.com/aptx1231)                      |
|                                     | GWNET          | [aptx1231](https://github.com/aptx1231)                      |
|                                     | MTGNN          | [aptx1231](https://github.com/aptx1231)                      |
|                                     | STMGAT         | [aptx1231](https://github.com/aptx1231)                      |
|                                     | TGCN           | [Asabaka](https://github.com/Asabaka), [aptx1231](https://github.com/aptx1231) |
|                                     | TGCLSTM        | [NickHan-cs](https://github.com/NickHan-cs), [aptx1231](https://github.com/aptx1231) |
|                                     | GTS            | [aptx1231](https://github.com/aptx1231), [buaacjw](https://github.com/buaacjw), [t123yh](https://github.com/t123yh), [h9tyf](https://github.com/h9tyf) |
|                                     | GMAN           | [huangjiawei128](https://github.com/huangjiawei128), [fry412](https://github.com/fry412) |
|                              `       | ATDM           | [zhangjiahui-buaa](https://github.com/zhangjiahui-buaa)      |
|                                     | HGCN           | [XBR-1111](https://github.com/XBR-1111), [Matty-blu](https://github.com/Matty-blu), [nan0054](https://github.com/nan0054), [PotassiumWings](https://github.com/PotassiumWings) |
|                                     | STAGGCN        | [a-l-r](https://github.com/a-l-r1), [aptx1231](https://github.com/aptx1231) |
| | DKFN | [a-l-r](https://github.com/a-l-r1), [aptx1231](https://github.com/aptx1231), [NickHan-cs](https://github.com/NickHan-cs) |
| | STTN | [NickHan-cs](https://github.com/NickHan-cs) |
| | TESTAM | [hczs](https://github.com/hczs) |
| | Trafformer | [hczs](https://github.com/hczs) |
|On-Demand Service Prediction|CCRNN|[aptx1231](https://github.com/aptx1231)|
|                                     |STG2Seq|[aptx1231](https://github.com/aptx1231), [Stevezzy](https://github.com/Stevezzy)|
||DMVSTNet|[l782993610](https://github.com/l782993610), [WANDY666](https://github.com/WANDY666)|
|OD Matrix Prediction|GEML|[l782993610](https://github.com/l782993610)|
||CSTN|[l782993610](https://github.com/l782993610)|
|Traffic Accidents Prediction|GSNet|[excelsior399](https://github.com/excelsior399)|
| Trajectory Next-Location Prediction | FPMC   | [WenMellors](https://github.com/WenMellors) |
|   | RNN-1  | [WenMellors](https://github.com/WenMellors) |
|  | STRNN | [BugMakerzzz](https://github.com/BugMakerzzz), [xcw-1010](https://github.com/xcw-1010), [WenMellors](https://github.com/WenMellors) |
||ATSTLSTM|[DrSpace](https://github.com/DrSpace), [hairfull](https://github.com/hairfull), [WenMellors](https://github.com/WenMellors)|
||SERM|[cwt-2021](https://github.com/cwt-2021), [Miffy623](https://github.com/Miffy623), [iceredteav](https://github.com/iceredteav), [WenMellors](https://github.com/WenMellors)|
||STAN|[JacquesdeH](https://github.com/JacquesdeH), [0-KaiKai-0](https://github.com/0-KaiKai-0), [WenMellors](https://github.com/WenMellors)|
||DeepMove|[WenMellors](https://github.com/WenMellors)|
||CARA|[aejion](https://github.com/aejion), [duckingss](https://github.com/duckingss)|
||LSTPM|[ssdrywz](https://github.com/ssdrywz), [Jerry18231174](https://github.com/Jerry18231174), [WenMellors](https://github.com/WenMellors)|
||GeoSAN|[Reinhard-Tichy](https://github.com/Reinhard-Tichy)|
||HSTLSTM|[Creddittale](https://github.com/Creddittale), [WenMellors](https://github.com/WenMellors)|
|Estimated Time of Arrival|DeepTTE|[NickHan-cs](https://github.com/NickHan-cs)|
||TTPNet|[NickHan-cs](https://github.com/NickHan-cs)|
|Map Matching|STMatching|[XBR-1111](https://github.com/XBR-1111)|
||IVMM|[excelsior399](https://github.com/excelsior399)|
||HMMM|[XBR-1111](https://github.com/XBR-1111)|
|Road Network Representation Learning|ChebConv|[aptx1231](https://github.com/aptx1231)|
||Node2Vec|[aptx1231](https://github.com/aptx1231)|
||DeepWalk|[aptx1231](https://github.com/aptx1231)|
||LINE|[l782993610](https://github.com/l782993610)|
||GAT|[Qwtdgh](https://github.com/Qwtdgh)|
||GeomGCN|[Aressfull](https://github.com/Aressfull)|





